# Copyright 1999-2024. Plesk International GmbH. All rights reserved.

# This Python module is designed to implement specific changes for mailing lists.
#
# It is meant to be used with the 'mailman withlist' command, expecting
# the target list to be passed as an argument named 'mlist'. The 'mailman' utility
# will automatically pass the list when you use the '-l [listname]' argument with it.
#
# The module should only be called through the mailman utility, as it relies
# on the context prepared by the utility. Attempting to call the module in any
# other way may result in "uninitialized context" problems.
#
# Further documentation on the 'withlist' sub-command can be found at the link provided:
# https://docs.mailman3.org/projects/mailman/en/latest/src/mailman/commands/docs/shell.html

def set_password(mlist, next_password):
    from mailman.database.transaction import transaction
    from mailman.config import config
    with transaction():
        mlist.moderator_password = config.password_context.encrypt(next_password).encode('us-ascii')
